/* { dg-do run } */
/* { dg-options "-O2 -fno-strict-aliasing -msse2" } */
/* { dg-additional-options "-mno-mmx" { target { ! ia32 } } } */

#include "sse2-check.h"
#include "mmx-vals.h"

__attribute__((noinline, noclone))
static void
test_psadbw  (long long *ll1, long long *ll2, long long *r)
{
  __m64 t1 = *(__m64 *) ll1;
  __m64 t2 = *(__m64 *) ll2;
  *(__m64 *) r = _m_psadbw (t1, t2);
}

/* Routine to manually compute the results */
static void
compute_correct_result (long long *dst_p, long long *src_p,
			long long *res_p)
{
  unsigned char *dst = (unsigned char *) dst_p;
  unsigned char *src = (unsigned char *) src_p;
  unsigned short *res = (unsigned short *) res_p;
  int i;
  int tmp;
  unsigned int sum = 0;
  for (i = 0; i < 8; i++)
    {
      tmp = dst[i] - src[i];
      if (tmp < 0)
	tmp = -tmp;
      sum += tmp;
    }
  res[0] = sum;
  for (i = 1; i < 4; i++)
    res[i] = 0;
}

static void
sse2_test (void)
{
  int i;
  long long r, ck;
  int fail = 0;

  /* Run the MMX tests */
  for (i = 0; i < MMX_num_ops; i += 2)
    {
      test_psadbw (&MMXops[i], &MMXops[i + 1], &r);
      compute_correct_result (&MMXops[i], &MMXops[i + 1], &ck);
      if (ck != r)
	fail++;
    }

  if (fail != 0)
    abort ();
}
